No Description
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

mass_deploy.sh 3.9KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141
  1. #!/bin/bash
  2. conffile="[@]LODEL2_CONFDIR[@]/mass_deploy.cfg"
  3. badconf() {
  4. echo -e "Either the file $conffile cannot be found or it didn't contains expected informations\n\nThe conffile is expected to define MONGODB_ADMIN_USER and MONGODB_ADMIN_PASSWORD variables" >&2
  5. exit 1
  6. }
  7. mongodb_connfail() {
  8. echo -e "Credential from $conffile seems to be incorrect. Unable to connect on admin db" >&2
  9. exit 2
  10. }
  11. usage() {
  12. echo -e "Usage : $0 (N|purgedb|-h|--help)
  13. \tWith :
  14. \t\t- N the number of instances to create
  15. \t\t- purgedb is to remove all created mongodb db\n"
  16. }
  17. slim_fails() {
  18. if [ -z "$1" ]
  19. then
  20. echo "SLIM fails for some reason. Abording..." >&2
  21. else
  22. echo "SLIM fails when $1. Abording...." >&2
  23. fi
  24. exit 1
  25. }
  26. test -f $conffile || badconf
  27. #Load conffile
  28. . $conffile
  29. test -z "$MONGODB_ADMIN_USER" && badconf
  30. test -z "$MONGODB_ADMIN_PASSWORD" && badconf
  31. #Check for the presence of /usr/share/dict/words to generate random names
  32. if [ -f '/usr/share/dict/words' ]
  33. then
  34. random_name=$(sed -nE 's/^([A-Za-z0-9]+)$/\1/p' /usr/share/dict/words |shuf|head -n1)
  35. else
  36. random_name=$RANDOM
  37. fi
  38. #Check for the presence of mongo and its conf
  39. if hash mongo 2>/dev/null
  40. then
  41. echo "Mongo found"
  42. else
  43. echo "You need mongo on this host to do a mass deploy !" >&2
  44. exit
  45. fi
  46. if [ -f "/etc/mongodb.conf" ]
  47. then
  48. if cat /etc/mongodb.conf |grep -E '^ *auth *= *true *$' >/dev/null
  49. then
  50. echo "OK, auth enabled"
  51. else
  52. echo "WARNING : auth seems disabled on mongod !" >&2
  53. fi
  54. else
  55. echo "/etc/mongodb.conf not found. Unable to check if auth is on"
  56. fi
  57. echo "exit" | mongo $MONGODB_HOST --quiet -u "$MONGODB_ADMIN_USER" -p "$MONGODB_ADMIN_PASSWORD" admin &>/dev/null || mongodb_connfail
  58. if [ "$1" == 'purgedb' ]
  59. then
  60. if [ -z "$MONGODB_DB_PREFIX" ]
  61. then
  62. echo -e "MONGODB_DB_PREFIX not indicated in $conffile. Using purgedb without prefix is really a bad idea... It will result in a deletion of ALL db.\nexiting."
  63. exit 3
  64. fi
  65. echo -n "Are you sure you want to delete all mongo database with name begining with '$MONGODB_DB_PREFIX' ? Y/n "
  66. read rep
  67. if [ "$rep" = "Y" ]
  68. then
  69. for dbname in $(echo "show dbs" | mongo -u admin -p pass admin |grep "^$MONGODB_DB_PREFIX"|cut -f1)
  70. do
  71. echo -e "use $dname\ndb.dropDatabase()\nexit\n" | mongo -u $MONGODB_ADMIN_USER -p $MONGODB_ADMIN_PASSWORD --quiet --authenticationDatabase admin $dbname && echo "$dbname succesfully deleted" || echo "$dbname deletion fails" >&2
  72. done
  73. echo "Done."
  74. else
  75. echo "You didn't answer 'Y' (case matters), exiting"
  76. fi
  77. exit
  78. elif echo $1 | grep -E "[A-Za-z]" &>/dev/null
  79. then
  80. usage
  81. exit 0
  82. fi
  83. #Check for the presence of pwgen for password generation
  84. if hash pwgen 2>/dev/null
  85. then
  86. echo "Using pwgen to generate passwords"
  87. rnd_pass_cmd='pwgen 25 1'
  88. else
  89. echo "pwgen not found !!! Using \$RANDOM to generate passwords"
  90. rnd_pass_cmd='$RANDOM'
  91. fi
  92. ninstance=$1
  93. instance=${ninstance:=50}
  94. echo -n "You are going to create $ninstance lodel2 instances. Are you sure ? Y/n "
  95. read rep
  96. if [ "$rep" = "Y" ]
  97. then
  98. echo "GO ! (you have 3 secs to cancel)"
  99. sleep 3
  100. else
  101. echo "You didn't answer 'Y' (case matters), exiting"
  102. exit
  103. fi
  104. echo "Creating instances"
  105. for i in $(seq $ninstance)
  106. do
  107. iname="${random_name}_$(printf "%05d" $i)"
  108. slim -n $iname -c || slim_fails "creating instance"
  109. slim -n $iname -s --interface web --static-url 'http://127.0.0.1/static' --uwsgi-workers 2 || slim_fails "configuring instancee"
  110. slim -n $iname -m || slim_fails "running make in instance"
  111. #Mongo db database creation
  112. dbname="${MONGODB_DB_PREFIX}_$iname"
  113. dbuser="lodel2_$iname"
  114. dbpass=$($rnd_pass_cmd)
  115. mongo $MONGODB_HOST -u "$MONGODB_ADMIN_USER" -p "$MONGODB_ADMIN_PASSWORD" admin <<EOF
  116. use $dbname
  117. db.addUser('$dbuser', '$dbpass', ['readWrite', '$dbname'])
  118. exit
  119. EOF
  120. #Append created db to instance conf
  121. slim -n $iname -s --datasource_connectors mongodb --host localhost --user $dbuser --password $dbpass --db_name $dbname || slim_fails "configuring the instance's datasource"
  122. done